/**************************************************
 *	
 *	Name:	FileParser.java
 *	Author: Walter Voit & Bill Fahle
 *	Date:	Feb '05
 *	Version: .82
 *	Comments: 
 *		combined all of the funcitons into one FileParser
 *		created the pipeline project that organizes all of the separate files
 * 
 *************************************************/
//package pancakes;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

// This class is used for handling the input and output when dealing
//with the text files that are used to pipeline the results
class FileParser
{
	private String filename; 	//name of the file to write to (input.txt)
	private String gpcase; 		//which case we encounter (9-1-9)
	private String objects;		//
	private String casenum;		//describes the case number ( (C_Z1_Z1) )
	private String nextcasenum; //stores the next case number
	private String nextgpcase;  //stores the next gp case
	private String inputString; 
	private FileReader fs;
	private BufferedReader r;
	private boolean newcase=true;
	public boolean singlecase=false;
	private BufferedWriter w;
	private String resultsFile = "results/results.txt";
	//private boolean caseSet;

	//this constructor creates the file reader and buffer reader
	FileParser(String fname) throws FileNotFoundException
	{
		this.filename = fname;
		this.fs = new FileReader(filename);
		this.r = new BufferedReader(fs);
		//this.caseSet = false;
		
		
		//initialize all of the strings to null strings
		this.nextcasenum = "";
		this.nextgpcase = "";
		this.gpcase = "_-_-_";
		
	}
	public String RemoveGoodBlocks()
	{
		try{		
		
			String buffer = "";
			String line = "";
			String result = "";
			int index=0;
			line = r.readLine();
			while (line != null)
			{
				if (line.length()>1)
				{
					buffer +=line+"\n";
	
					if (line.startsWith("b:"))
					{
						index = line.indexOf("x:");
						result = line.substring(index);
						if ((result.indexOf('-')<0)&&(result.indexOf(" 0/")<0))
						{
							return buffer;
						}
						else 
						{
							try{
								this.w = new BufferedWriter(new FileWriter(resultsFile, true));
								char[] slashn = {'\\','n'};
								String[] lines = Split(buffer, slashn);
								for(int count = 0; count <lines.length; count++)
								{
									this.w.write(lines[count]);
									this.w.newLine();
								}
								this.w.newLine();
								this.w.close();
							}
							catch (IOException e){}
							return "";
						}
							
						
					}
					else if (line.charAt(1)=='-')
					{
						return buffer;
					}
				}
				line = r.readLine();
				
			}
			return null;
		}
		catch(IOException e){return null;}
		
		
		
	}
	
	
	//called from the pancake files
	public boolean pancakeMore()
	{
		objects = "";
		casenum=nextcasenum;
		if (nextgpcase.length() > 0)
		{
			gpcase = nextgpcase;
			newcase = true;
			nextgpcase = "";
		}
		try 
		{
			boolean done = false;
			while(!done)
			{
				String str = r.readLine();
				if (str != null)
				{
					str = str.trim();
					if (str.length() > 0)
					{
						if (str.startsWith("("))
						{
							if (objects.length() > 0)
							{
								done = true;
								nextcasenum = str;
							}
							else
							{
								casenum = str;
							}
						}
						else if ((str.charAt(1) == '-')||((str.charAt(1) == '.')&&(str.charAt(3) == '-')))
						{
							if (objects.length() > 0)
							{
								nextgpcase = str;
								done = true;
							}
							else
							{
								gpcase = str;
								newcase = true;
							}
						}
						else if (objects.length() == 0)
						{
							objects = str;
						}
						else if (str.charAt(1) == ':')
						{
							done = true;
						}
					}
				}
				else
					done = true;
			}
		}
		catch(IOException ioex)
		{
			return false;
		}
		if (objects.length() != 0)
			return true;
		else
		{
			try 
			{
				r.close();
			}
			catch(IOException ioex)
			{
			}
			return false;
		}
	}	
	
	//called from NumberAppender
	public String getAppendLine()
	{
		try 
		{
			String str = r.readLine();
			if (str != null)
			{
				if (str.length() > 0)
				{
					str = str.trim();
					if (str.charAt(1) == '-')
					{
						return str;
					}
					else if (str.charAt(0) == '(')
					{
						String str1 = r.readLine();
						while(str1 == null )
							str1 = r.readLine();										
						return str + "\n" + str1;
					}
					else
					{
						return "";
					}
				}
			}
			else
				return "FileDone";
			
		}
		catch(IOException ioex)
		{
			return "FileDone";
		}
		return "";
		
	}
	
	//called from NumberAppender and StringInput
	public boolean appendAndInputMore()
	{
		objects = "";
		casenum=nextcasenum;
		if (nextgpcase.length() > 0)
		{
			gpcase = nextgpcase;
			newcase = true;
			nextgpcase = "";
		}
		try 
		{
			boolean done = false;
			while(!done)
			{
				String str = r.readLine();
				if (str != null)
				{
					str = str.trim();
					if (str.length() > 0)
					{
						if (str.charAt(1) == '-')
						{
							if (objects.length() > 0)
							{
								nextgpcase = str;
								done = true;
							}
							else
							{
								gpcase = str;
								newcase = true;
							}
						}
						else if (str.charAt(0) == '(')
						{
							if (objects.length() > 0)
							{
								done=true;
								nextcasenum = str;
							}
							else
							{
								casenum = str;
							}
						}
						else if (objects.length() == 0)
						{
							objects = str;
						}
						else if (str.charAt(1) == ':')
						{
							done = true;
						}
						else
						{
							inputString = str;
							done = true;							
						}
					}
				}
				else
					done = true;
			}
		}
		catch(IOException ioex)
		{
			return false;
		}
		if (objects.length() != 0)
			return true;
		else
		{
			try 
			{
				r.close();
			}
			catch(IOException ioex)
			{
			}
			return false;
		}
	}

	public String[] Split(String in, char[] onthese)
	{
		return in.split(new String(onthese));
	}	
	//called from StringInput
	public String getBlock()
	{
		try 
		{
			int count=0;
			String buffer = "";
			String[]cases;
			
			//set block to saved GP case
			if (this.gpcase!=null)
			{
				buffer = this.gpcase+ "\n";
				char[] dash = {'-'};
				cases = Split(this.gpcase, dash);
				count = cases.length;
				//caseSet = false;
			}
			
			//loop until the block is finsihed and we return
			while (true)
			{
				String str = r.readLine();
				if (str==null)
					return "FileDone";

				else if (str.startsWith("Input Scenario:"))
				{		
					//caseSet = true;
					this.gpcase = str.substring(str.indexOf(':')+1);
					//buffer = this.gpcase + "\n";
					if (this.gpcase.trim().length()== 2)
					{
						count = 1;
						singlecase = true;
					}
					else
					{
						char[] dash = {'-'};	
						cases = Split(this.gpcase,dash);
						count = cases.length;
					}
				}	
				else if (str.startsWith("("))
				{
                    //if (!caseSet)
                    buffer=this.gpcase + "\n";
                    //caseSet=true;
					buffer += str + "\n";
				}
				else if (str.startsWith("Input String:"))
				{
					buffer += str.substring(str.indexOf(":")+1)+"\n";
				}	
				else if (str.startsWith("New String after merging:"))
				{
					count--;
					if (count == 0)
					{
						buffer += str.substring(str.indexOf(":")+1);
						return buffer;
					}
				}
			}							
		}
		catch(IOException ioex)
		{
			return "FileDone";
		}
		
	}
	
	//tells whether we have a new case
	public boolean newcase()
	{
		boolean ret = newcase;
		newcase = false;
		return ret;
	}
	
	//access to private variables
	public String inputString()
	{
		return inputString;
	}
	
	//access to private variables
	public String objects()
	{
		return objects;
	}
	
	//access to private variables
	public String gpcase()
	{
		return gpcase;
	}
	
	//access to private variables
	public String casenum()
	{
		return casenum;
	}
}
