/**************************************************
 *	
 *	Name:	FileParser.java
 *	Author: Bill Fahle & Walter Voit
 *	Date:	Feb '05
 *	Version: .82
 *	Comments: 
 *		provides the flipping mechanism in the pancake code
 * 
 *************************************************/
//package pancakes;


class Flipper
{
	int maxDepth;	//indicates the number of levels to which we will recurse
	int best=Perm.FLIP_COEF; // value = 135: 0 is better - = G&P
	int bestDepth = 0;
	int[] bestFlip;
	boolean inputDepth;
	boolean findBest;
	//new constructor
	Flipper(int depth, boolean idepth, boolean findBest)
	{
		maxDepth = depth;
		bestFlip = new int[depth+1];
		this.inputDepth = idepth;
		this.findBest = findBest;
	}

	// recursively flip
	boolean recurse(Perm perm, int i, int depth)
	{
		//if ( earlyReturn == true)
		// {return true;}
		boolean ret = false;
		perm.flip(i);
		if (perm.postFlip(i)) // if postflip, it had some effect
		{
			//			System.out.print("!");
		
			if (perm.score() < best || (perm.score() == best && depth < bestDepth))
			{
				best = perm.score();
				bestDepth = depth;
				//				System.out.println("_");
				// include new permutation
				ret = true;
				if ( this.best<= 0 )
				{
					if (!findBest) 
						return ret; 
				}
		    }
		}
		int adj = perm.adjacencies();

		if (depth > 1 && depth > adj && adj > 0)
		{
			for (int j=2; j<perm.length(); j++)
			{
				if (perm.legalFlip(j))
				{
					if (recurse(new Perm(perm), j, depth-1))
					{
						bestFlip[depth-1]=j;
						ret = true;
						if (this.best<=0) 
						{
							if (!findBest)
								return ret;
						}
					}
					
				}
				// if ( earlyReturn == true) {break;}
			}
			
		}
		return ret;
	}

	void dfs(Perm perm)
	{
		// flipping a singleton on front is useless; start at 2
		for (int i=2; i<perm.length(); i++) // note that a single group at front which can be affected by a flip will start blank at 3 (Ac ) for example
		{
			if (perm.legalFlip(i))
				if (recurse(new Perm(perm), i, maxDepth))
					bestFlip[maxDepth] = i;
			if (this.best <= 0)
			{
				if (!findBest)
					break;
			}
		}
		//		System.out.println("");
	}
}
