//package pancakes;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.awt.TextArea;


public class Pancake {
	
	protected BufferedWriter outfile;
	protected boolean inputDepth = false;
	public boolean findBest = false;
	public long startTime;
	public int startCount;
	public int failedCount;
	public long stopTime;
	public String inputString;
	public String inputControl;
	public String outputString;
	public int depthControl;
	public TextArea t;
	public int depthSubtractor;
	
	Pancake()
	{
		this.inputString = "";
		this.outputString = "";
		
	}
	protected void setTextArea(TextArea text)
	{
		this.t = text;		
	}
	
	protected void lineOut(String str)
	{
		if (t!=null)
		{
			t.append(str);
			t.append("\n");			
		}
		if (str != null && outputString != null && !(outputString.equals("")))
		{
		    try {
		        outfile = new BufferedWriter(new FileWriter(outputString, true));
				outfile.write(str);
				outfile.newLine();
				outfile.close();
			}
			catch (IOException e){}
		}
	}
	protected void clearTextFile(String file)
	{
	    try {
	        outfile = new BufferedWriter(new FileWriter(file, false));
			outfile.close();
		}
		catch (IOException e){}
		
	}
	protected void run(){}
	
	protected int[] getInfo(String inp)
	{
		int len = inp.length();
		int adj = 0;
		int depth = 0;
		if (len == 0)
		{
			int leni = inputString.length();
			int singleton = 0;
			int block = 0;
			for (int i=0; i<leni; i++)
			{
				char ch = inputString.charAt(i);
				if (ch == '~' || ch == '+')
					block++;
				if ((ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z'))
				{
					if ((i == leni-1 && inputString.charAt(i-1) == ' ') || (i == 0 && inputString.charAt(i+1) == ' ') ||
						(i != 0 && i != leni-1 && inputString.charAt(i-1) == ' ' && inputString.charAt(i+1) == ' '))
						singleton++;
					if (i == leni-1 || inputString.charAt(i+1) == ' ' || i == 0 || inputString.charAt(i-1) == ' ')
					{
						for (int j=0; j<leni; j++) // look for adjacency
						{
							char cc = inputString.charAt(j);
							if (cc == ch-1 || cc == ch+1 || (ch == 'Z' && cc == 'a') || (cc == 'Z' && ch == 'a'))
								adj++;
						}
					}
				}
			}
			adj = adj/2; // counted each one twice
			depth = (((block-1)*7+singleton*5)+2)/3;
		}
		char[] ch = new char[len];
		inp.getChars(0, len, ch, 0);
		for (int i=0; i<len; i++)
		{
			switch (ch[i])
			{
				case 11:
					depth+=3; // G&P take one step to "solve" this
					adj+=2; // forms one adjacency
					break;
				case 12:
					depth+=3; // G&P take one step to "solve" this
					adj+=2; // forms one adjacency
					break;
				case 13:
					depth+=3; // G&P take one step to "solve" this
					adj+=2; // forms one adjacency
					break;
				case '1':
					depth++; // G&P take one step to "solve" this
					adj++; // forms one adjacency
					break;
				case '2':
					depth++; // G&P take one step to "solve" this
					adj++; // forms one adjacency
					break;
				case '3':
					depth+=4;
					adj+=2;
					break;
				case 'h': //represents the half of case 3
					depth +=2;
					adj++;
				case '4':
					depth++;
					adj++;
					break;
				case '5':
					depth++;
					adj++;
					break;
				case '6':
					depth+=2;
					adj+=1;
					break;
				case '7':
					depth+=2;
					adj+=1;
					break;
				case '8':
					depth+=4;
					adj+=2;
					break;
				case '9':
					depth+=4;
					adj+=2;
					break;
				default:
					break;
			}
		}
		int[] ret = new int[2];
		ret[0] = adj;
		ret[1] = this.depthControl; //In3.getParam();
		if (ret[1] == 0)
		{
			ret[1] = depth-this.depthSubtractor;
			ret[1] = Math.max(ret[1], 0);
		}
		else
			this.inputDepth = true;
		return ret;
	}

	protected void begin(String[] args) // alternate entry point for non-applet
	{
		//setting up a timer to record how long the computation takes.
		startTime = System.currentTimeMillis();
		String str = args[0].trim();
		inputString = str;
		int[] ret = getInfo(args[1]);
		startCount = 0;
		failedCount = 0;
		lineOut(str);
		if (str.indexOf("*") == -1) // no star, normal string
			doOne(str, ret);
		else
		{
			int idx = str.lastIndexOf("_");
			String wildcard = str.substring(idx+1, str.length()-1).trim();
			if (str.substring(idx).indexOf("*") == -1) // we know there is a star, but not at the end. so just do the s s~ thing
			{
				idx = str.indexOf("*"); // half a wild?
				if (str.charAt(idx - 1) == ' ') // "A _ *s X _ t~"
				{
					String strbeg = str.substring(0, idx);  // "A _ "
					String strend = str.substring(idx + 1); // "s X _"
					doOne(strbeg + strend, ret);
					doOne(strbeg + "~" + strend, ret);
					doOne(strbeg.substring(0, strbeg.length() - 2) + strend.substring(2), ret); // "A" + " X _"
				}
				else if (idx > 2 && str.charAt(idx - 3) == '_') // X _ s* _ Y _ t~
				{
					String strbeg = str.substring(0, idx); // "X _ s"
					String strend = str.substring(idx + 1);// " _ Y _"
					doOne(strbeg + strend, ret);
					doOne(strbeg + "~" + strend, ret);
					doOne(strbeg.substring(0, strbeg.length() - 1) + "~" + strbeg.substring(idx-1, idx)+ strend, ret); // "X _ " + "~" + "s" + " _ Y _"
					doOne(strbeg.substring(0, strbeg.length() - 4) + strend.substring(2), ret); // "X"+" Y _"
				}
				else // X s* _ Y _ t~
				{
					String strbeg = str.substring(0, idx); // "X s"
					String strend = str.substring(idx + 1);// " _ Y _"
					doOne(strbeg + strend, ret);
					doOne(strbeg + "~" + strend, ret);
					doOne(strbeg.substring(0, strbeg.length() - 2) + strend.substring(2), ret); // "X"+" Y _"
				}
			}
			else
			{
				str = str.substring(0, idx + 1).trim();
				idx = str.indexOf("*"); // wild and a half?
				if (idx == -1) // single wild, just s _ t*
				{
					if (wildcard.length() > 2) // s*t* at end
						doubleWild(str, ret, wildcard);
					else
						doWild(str, ret, wildcard, null);
				}
				else	// "X s* _ t*" so s* is just s or s~, or "A _ *s X _ t*", where *s is ~s or s at end of blank
				{
					if (str.charAt(idx - 1) == ' ') // "A _ *s X _ t*"
					{
						String strbeg = str.substring(0, idx);  // "A _ "
						String strend = str.substring(idx + 1); // "s X _"
						doWild(strbeg + strend, ret, wildcard, null);
						doWild(strbeg + "~" + strend, ret, wildcard, strend.substring(0, 1));
						doOne(strbeg.substring(0, strbeg.length() - 2) + strend.substring(2), ret); // "A" + " X _"
					}
					else if (idx > 2 && str.charAt(idx - 3) == '_') // A _ s* _ X _ t*
					{
						String strbeg = str.substring(0, idx); // "A _ s"
						String strend = str.substring(idx + 1);// " _ X _"
						doWild(strbeg + strend, ret, wildcard, null);
						doWild(strbeg + "~" + strend, ret, wildcard, null);
						doWild(strbeg.substring(0, strbeg.length() - 1) + "~" + strbeg.substring(idx - 1, idx) + strend, ret,wildcard, null); // "A _ " + "~" + "s" + " _ X _"
						doOne(strbeg.substring(0, strbeg.length() - 4) + strend.substring(2), ret); // "A"+" X _"

					}
					else // X s* _ Y _ t*
					{
						String strbeg = str.substring(0, idx); // "X s"
						String strend = str.substring(idx + 1);// " _ Y _"
						doWild(strbeg + strend, ret, wildcard, null);
						doWild(strbeg + "~" + strend, ret, wildcard, strbeg.substring(idx - 1));
						doOne(strbeg.substring(0, strbeg.length() - 2) + strend.substring(2), ret); // "X"+" Y _"
					}
				}
			}
		}
		lineOut("failed: " + failedCount);
		lineOut("Finished.");
	}

	protected void doUsed(String start, String end, int[] ret)
	{
		String both = start + end;
		for (int i = 0; i < both.length(); i++)
		{
			char c = both.charAt(i);
			if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z'))
			{
				char candidate = (char)(c - 1);
				boolean errorcase = (c == 'a' || c == 'A');
				int adjacent = 0;
				if (i > 0 && both.charAt(i - 1) == '~')
				{
					adjacent = 1; // b~ is our string; if there is an a or c, we're done, else our candidate is a arbitrarily
				}
				for (int j = 0; j < both.length(); j++)
				{
					char d = both.charAt(j);
					if (d == c - 1 || d == c + 1)
					{
						adjacent++;
						if (d == c - 1)
						{
							candidate = (char)(c + 1);
							errorcase = (c == 'z' || c == 'Z');
						}
					}
				}
				if (adjacent < 2)
				{
					if (errorcase)
						lineOut("Error: c is " + c);
					else
						doOne(start + candidate + end, ret);
				}
			}
		}

	}

	protected void doubleWild(String str, int[] ret, String wildcard)
	{
		String wild1 = wildcard.substring(0,1);
		String wild2 = wildcard.substring(2);
		for (int loc = 0; loc < str.length(); loc++)
		{
			if (str.charAt(loc) == '_')
			{
				if (startCount > 0)
				{
					lineOut("failed: " + failedCount);
				}
				lineOut("-------------");
				startCount = 0;
				failedCount = 0;
				String wildstr = str.substring(0, loc);
				String endstr = str.substring(loc);
				lineOut(wildstr + wild1 + "*" + endstr + " " + wild2 + "*");
				doWild(wildstr + wild1+" "+endstr,ret,wild2,wild1);   // X a _ Y b*
				doUsed(wildstr, " " + endstr, ret);
				doWild(wildstr + wild1 + "~ " + endstr, ret, wild2, wild1); // X a~ _ Y b*
				doUsed(wildstr, "~ " + endstr, ret);
				doOne(wildstr.substring(0, wildstr.length() - 1) + endstr.substring(1), ret); // X Y in case there is nothing in the blank
				lineOut("failed: " + failedCount);
				lineOut("-------------");
				startCount = 0;
				failedCount = 0;
				lineOut(wildstr + "_ *" + wild1 + endstr.substring(1) + " " + wild2 + "*");
				doWild(wildstr + "_ ~" + wild1 + endstr.substring(1), ret, wild2, wild1); // X _ ~a Y b*
				doUsed(wildstr + "_ ~", endstr.substring(1), ret);
				doWild(wildstr + "_ " + wild1 + endstr.substring(1), ret, wild2, wild1); // X _ a Y b*
				doUsed(wildstr + "_ ", endstr.substring(1), ret);
				doOne(wildstr.substring(0, wildstr.length() - 1) + endstr.substring(1), ret); // X Y in case there is nothing in the blank
			}
			if (str.charAt(loc) == '~' || str.charAt(loc) == '+')
			{
				if (loc > 0 && str.charAt(loc-1) == ' ')
				{
					if (startCount > 0)
					{
						lineOut("failed: " + failedCount);
					}
					lineOut("-------------");
					startCount = 0;
					failedCount = 0;
					String wildstr = str.substring(0, loc);
					String endstr = str.substring(loc);
					lineOut(wildstr + wild1 + endstr + " " + wild2 + "*");

					doWild(wildstr+wild1+endstr,ret,wild2, wild1);

				}
				else if (loc < str.length()-1 && str.charAt(loc+1) == ' ')
				{
					if (startCount > 0)
					{
						lineOut("failed: " + failedCount);
					}
					lineOut("-------------");
					startCount = 0;
					failedCount = 0;
					String wildstr = str.substring(0, loc + 1);
					String endstr = str.substring(loc+1);
					lineOut(wildstr + wild1 + endstr + " " + wild2 + "*");

					doWild(wildstr+wild1+endstr,ret,wild2,wild1);
				}
			}
		}

	}

	protected void doWild(String str, int[] ret, String wildcard, String dWild)
	{
		for (int loc = 0; loc < str.length(); loc++)
		{
			if (str.charAt(loc) == '_')
			{
				String wildstr = str.substring(0,loc);
				String endstr = str.substring(loc);

				doOne(wildstr+"_ " + wildcard+" "+endstr,ret);
				doOne(wildstr+"_ " + wildcard+"~ "+endstr,ret);
				doOne(wildstr+"_ ~" + wildcard+" "+endstr,ret);
			}
			if (str.charAt(loc) == '~' || str.charAt(loc) == '+')
			{
				if (loc > 0 && str.charAt(loc-1) == ' ')
				{
					String wildstr = str.substring(0,loc);
					String endstr = str.substring(loc);
					if (wildstr.substring(loc - 1).equals(dWild + "~") || endstr.substring(0, 2).equals("~" + dWild))
						System.out.println(wildstr + wildcard + endstr);
					else
						doOne(wildstr + wildcard + endstr, ret);

				}
				else if (loc < str.length()-1 && str.charAt(loc+1) == ' ')
				{
					String wildstr = str.substring(0,loc+1);
					String endstr = str.substring(loc+1);

					if (wildstr.substring(loc - 1).equals(dWild + "~"))
						System.out.println(wildstr + wildcard + endstr);
					else
						doOne(wildstr + wildcard + endstr, ret);
				}
			}
		}

	}

	protected void doOne(String str, int[] ret)
	{
		
		/* *****************************************
		 * these two are the input parameters
		 * String str = "b _ Aa _ Bc _"; // case 3
		 * int depth = 4; // represents G&P time
		 * 		String str = "b _ Aa x _ Bc _ Cy _ Dw _"; // case 3-3-e
		 * 		int depth = 8; // represents G&P time
		 * 		String str = "e _ iA _ gBf h _ cCd _"; // case 3-3-h
		 * 		int depth = 8;
		 * 		String str = "b _ yC _ wD _ Aa x _ Bc _"; // case 3-3-d
		 * 		int depth = 8;
		 * 		int adj = 4;
		 * 		String str = "a _ q _ p b _"; // case 1-1, only has 2 adjacencies, for testing
		 * 		int depth = 2;
		 * 		int adj = 2;
		 * 		String str = "e _ gBf h _ Ai _ cCd _"; // case 3-3-g
		 * 		int depth = 8;
		 * 		int adj = 4;
		 * 		String str = "b _ Aa g _ jC _ o t _ Es _ Eu _ n lD _ k h _ Bc _"; // case 3-1-3-1-3
		 * 		String str = "b _ h k _ Dl n _ uE _ sE _ t o _ Cj _ Aa g _ Bc _"; // case 3-1-3-1-3
		 * 		int depth = 12; // represents G&P time
		 * 		int adj = 8;
		 * 
		 **************************************/
		startCount++;
		String startStr="";
		if (startCount > 702)
		{
			startStr = startStr + new Character((char)(((startCount-1 / 702) - 1) + 'a')).toString();
		}
		if (startCount > 26)
		{
			startStr = startStr + new Character((char)(((((startCount-1) % 702)/26)-1) + 'a')).toString();
		}
		startStr = startStr + new Character((char)(((startCount-1) % 26) + 'a')).toString();
		lineOut("("+startStr+")");
		int adj = ret[0];
		int depth = ret[1];
		Perm p = new Perm(str, adj);
		char[] sv = p.ch();
		for (int i = 0; i < str.length(); i++)
		{
			if (p.postFlip(i))
			{
				sv[i] = '*';
				lineOut(new String(sv));
				lineOut("b: " + p.block() +
					" s: " + p.sing() +
					" f: " + p.flip() + " score: " + p.score() + "/" + Perm.FLIP_COEF);
				return;
			}
		}

		Flipper flip = new Flipper(depth, inputDepth, findBest); //, In4.getCheckBoxStatus());
		flip.dfs(p);
		p = new Perm(str, adj);
		char[] ch = p.ch();
		if (flip.bestFlip[flip.maxDepth]>0)
		{
			ch[flip.bestFlip[flip.maxDepth]] = '|';
			lineOut(new String(ch));
			ch[flip.bestFlip[flip.maxDepth]] = ' ';
		}
		else
			lineOut(new String(ch));
		for (int i=flip.maxDepth; i>flip.bestDepth-1; i--)
		{
			//			System.out.println(flip.bestFlip[i]);
			p.flip(flip.bestFlip[i]);
			//			System.out.println(new String(p.ch()));
			p.postFlip(flip.bestFlip[i]);
			ch = p.ch();
			if (i>flip.bestDepth)
				ch[flip.bestFlip[i-1]] = '|';
			lineOut(new String(ch));
			if (i>flip.bestDepth)
				ch[flip.bestFlip[i-1]] = ' ';
//			if ((!best)&&(p.score()<=0))
//				break;
		}
//		printTimeTaken();
		lineOut("b: " + p.block() + 
			" s: " + p.sing() +
			" f: " + p.flip() + " score: " + p.score() + "/" + Perm.FLIP_COEF);
		if (p.score() > 0)
			failedCount++;
		lineOut("");	

	}


	
	protected void printTimeTaken()
	{
		stopTime = System.currentTimeMillis()-startTime;
		long msecs = stopTime % 1000;
		stopTime /= 1000;
		long secs = stopTime % 60;
		stopTime /=60;
		long mins = stopTime % 60;
		stopTime /=60;
		long hours = stopTime;
		String str = "time: ";
		if (hours != 0)
			str += hours + " hours, ";
		if ((mins != 0) || (hours != 0))
			str += mins + " mins, ";
		if ((secs != 0) || (mins != 0) || (hours != 0))
			str += secs + " secs, and ";
		str += msecs + " msecs";
			lineOut(str);		
	}
	
}





// format:
// Ab	group connects to c or cD on right
// gAb group connects to c or cD on right, f or Ef on left
// so case three looks like this:
// b _ Aa _ Bc _
// when a flip is done, we need to consolidate group gAb c to gAc
